diff --git a/src/mongo/bson/util/bswap.h b/src/mongo/bson/util/bswap.h
new file mode 100644
index 0000000..b372def
--- /dev/null
+++ b/src/mongo/bson/util/bswap.h
@@ -0,0 +1,522 @@
+
+#pragma once
+
+#ifndef MONGO_BSWAP_H
+#define MONGO_BSWAP_H
+
+#include "boost/detail/endian.hpp"
+#include "boost/static_assert.hpp"
+#include <string.h>
+
+#ifdef __APPLE__
+#  include <libkern/OSByteOrder.h>
+#endif
+
+namespace mongo {
+   class Nullstream;
+
+   // Generic (portable) byte swap function
+   template<class T> T byteSwap( T j ) {
+       
+#ifdef HAVE_BSWAP32
+       if ( sizeof( T ) == 4 ) {
+           return __builtin_bswap32( j );
+       }
+#endif
+#ifdef HAVE_BSWAP64
+       if ( sizeof( T ) == 8 ) {
+           return __builtin_bswap64( j );
+       }
+#endif
+
+      T retVal = 0;
+      for ( unsigned i = 0; i < sizeof( T ); ++i ) {
+         
+         // 7 5 3 1 -1 -3 -5 -7
+         int shiftamount = sizeof(T) - 2 * i - 1;
+         // 56 40 24 8 -8 -24 -40 -56
+         shiftamount *= 8;
+
+         // See to it that the masks can be re-used
+         if ( shiftamount > 0 ) {
+            T mask = T( 0xff ) << ( 8 * i );
+            retVal |= ( (j & mask ) << shiftamount );
+         } else {
+            T mask = T( 0xff ) << ( 8 * (sizeof(T) - i - 1) );
+            retVal |= ( j >> -shiftamount ) & mask;
+         }
+      }
+      return retVal;
+   }
+
+   template<> inline double byteSwap( double j ) {
+      union {
+         double d;
+         unsigned long long l;
+      } u;
+      u.d = j;
+      u.l = byteSwap<unsigned long long>( u.l );
+      return u.d;
+   }
+
+
+   // Here we assume that double is big endian if ints are big endian
+   // and also that the format is the same as for x86 when swapped.
+   template<class T> inline T littleEndian( T j ) {
+#ifdef BOOST_LITTLE_ENDIAN
+      return j;
+#else
+      return byteSwap<T>(j);
+#endif
+   }
+
+   template<class T> inline T bigEndian( T j ) {
+#ifdef BOOST_BIG_ENDIAN
+      return j;
+#else
+      return byteSwap<T>(j);
+#endif
+   }
+
+#if defined(__arm__) 
+#  if defined(__MAVERICK__)
+#    define MONGO_ARM_SPECIAL_ENDIAN
+   // Floating point is always little endian
+   template<> inline double littleEndian( double j ) {
+       return j;
+   }
+#  elif defined(__VFP_FP__) || defined( BOOST_BIG_ENDIAN )
+   // Native endian floating points even if FPA is used
+#  else
+#    define MONGO_ARM_SPECIAL_ENDIAN
+   // FPA mixed endian floating point format 456701234
+   template<> inline double littleEndian( double j ) {
+      union { double d; unsigned u[2]; } u;
+      u.d = j;
+      std::swap( u.u[0], u.u[1] );
+      return u.d;
+   }
+#  endif
+#  if defined(MONGO_ARM_SPECIAL_ENDIAN)
+   template<> inline double bigEndian( double j ) {
+      return byteSwap<double>( littleEndian<double>( j ) );
+   }
+#  endif
+#endif
+
+
+   BOOST_STATIC_ASSERT( sizeof( double ) == sizeof( unsigned long long ) );
+
+   template<class S, class D> inline D convert( S src )
+   {
+      union { S s; D d; } u;
+      u.s = src;
+      return u.d;
+   }
+
+   template<> inline char convert<bool,char>( bool src ) {
+      return src;
+   }
+
+   template<> inline bool convert<char, bool>( char src ) {
+      return src;
+   }
+
+
+#define MONGO_ENDIAN_BODY( MYTYPE, BASE_TYPE, T )                       \
+      MYTYPE& operator=( const T& val ) {                               \
+          BASE_TYPE::_val = val;                                        \
+          return *this;                                                 \
+      }                                                                 \
+                                                                        \
+      operator const T() const {                                        \
+          return BASE_TYPE::_val;                                       \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator+=( T other ) {                                   \
+          (*this) = T(*this) + other;                                   \
+          return *this;                                                 \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator-=( T other ) {                                   \
+          (*this) = T(*this) - other;                                   \
+          return *this;                                                 \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator&=( T other ) {                                   \
+          (*this) = T(*this) & other;                                   \
+          return *this;                                                 \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator|=( T other ) {                                   \
+          (*this) = T(*this) | other;                                   \
+          return *this;                                                 \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator^=( T other ) {                                   \
+          (*this) = T(*this) ^ other;                                   \
+          return *this;                                                 \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator++() {                                            \
+          return (*this) += 1;                                          \
+      }                                                                 \
+                                                                        \
+      MYTYPE operator++(int) {                                          \
+          MYTYPE old = *this;                                           \
+          ++(*this);                                                    \
+          return old;                                                   \
+      }                                                                 \
+                                                                        \
+      MYTYPE& operator--() {                                            \
+          return (*this) -= 1;                                          \
+      }                                                                 \
+                                                                        \
+      MYTYPE operator--(int) {                                          \
+          MYTYPE old = *this;                                           \
+          --(*this);                                                    \
+          return old;                                                   \
+      }                                                                 \
+                                                                        \
+      friend std::ostream& operator<<( std::ostream& ost, MYTYPE val ) { \
+          return ost << T(val);                                         \
+      }                                                                 \
+                                                                        \
+      friend Nullstream& operator<<( Nullstream& ost, MYTYPE val ) {    \
+          return ost << T(val);                                         \
+      }
+  
+
+  template<class T, class D> void storeLE( D* dest, T src ) {
+#if defined(BOOST_LITTLE_ENDIAN) || !defined( ALIGNMENT_IMPORTANT )
+      // This also assumes no alignment issues
+      *dest = littleEndian<T>( src );
+#else
+      unsigned char* u_dest = reinterpret_cast<unsigned char*>( dest );
+      for ( unsigned i = 0; i < sizeof( T ); ++i ) {
+         u_dest[i] = src >> ( 8 * i );
+      }
+#endif
+   }
+   
+  template<class T, class S> T loadLE( const S* data ) {
+#ifdef __APPLE__
+      switch ( sizeof( T ) ) {
+      case 8:
+          return OSReadLittleInt64( data, 0 );
+      case 4:
+          return OSReadLittleInt32( data, 0 );
+      case 2:
+          return OSReadLittleInt16( data, 0 );
+      }
+#endif
+
+#if defined(BOOST_LITTLE_ENDIAN) || !defined( ALIGNMENT_IMPORTANT )
+#if defined(__powerpc__)
+      // Without this trick gcc (4.4.5) compiles 64 bit load to 8 byte loads.
+      if ( sizeof( T ) == 8 ) {
+          const unsigned * x = reinterpret_cast<const unsigned*>( data );
+          unsigned long long a = loadLE<unsigned, unsigned>( x );
+          unsigned long long b = loadLE<unsigned, unsigned>( x + 1 ); 
+          return a | ( b << 32 );
+      }
+#endif
+      return littleEndian<T>( *data );
+#else
+      T retval = 0;
+      const unsigned char* u_data = reinterpret_cast<const unsigned char*>( data );
+      for( unsigned i = 0; i < sizeof( T ); ++i ) {
+          retval |= T( u_data[i] ) << ( 8 * i );
+      }
+      return retval;
+#endif
+  }
+
+  template<class T, class D> void store_big( D* dest, T src ) {
+#if defined(BOOST_BIG_ENDIAN) || !defined( ALIGNMENT_IMPORTANT )
+      // This also assumes no alignment issues
+      *dest = bigEndian<T>( src );
+#else
+      unsigned char* u_dest = reinterpret_cast<unsigned char*>( dest );
+      for ( unsigned i = 0; i < sizeof( T ); ++i ) {
+          u_dest[ sizeof(T) - 1 - i ] = src >> ( 8 * i );
+      }
+#endif
+   }
+   
+  template<class T, class S> T load_big( const S* data ) {
+
+      if ( sizeof( T ) == 8 && sizeof( void* ) == 4 ) {
+          const unsigned * x = reinterpret_cast<const unsigned*>( data );
+          unsigned long long a = load_big<unsigned, unsigned>( x );
+          unsigned long long b = load_big<unsigned, unsigned>( x + 1 );
+          return a << 32 | b;
+      }
+
+#if defined(BOOST_BIG_ENDIAN) || !defined( ALIGNMENT_IMPORTANT )
+      return bigEndian<T>( *data );
+#else
+      T retval = 0;
+      const unsigned char* u_data = reinterpret_cast<const unsigned char*>( data );
+      for( unsigned i = 0; i < sizeof( T ); ++i ) {
+          retval |= T( u_data[ sizeof(T) - 1 - i ] ) << ( 8 * i );
+      }
+      return retval;
+#endif
+  }
+
+
+  /** Converts the type to the type to actually store */
+  template<typename T> class storage_type {
+  public:
+      typedef T t;
+      
+      static inline t toStorage( T src ) { return src; }
+      static inline T fromStorage( t src ) { return src; }
+
+  };
+
+  template<> class storage_type<bool> {
+  public:
+      typedef unsigned char t;
+
+      static inline t toStorage( bool src ) { return src; }
+      static inline bool fromStorage( t src ) { return src; }      
+      
+  };
+
+  template<> class storage_type<double> {
+  public:
+      typedef unsigned long long t;
+
+      static inline t toStorage( double src ) { return convert<double,t>( src ); }
+      static inline double fromStorage( t src ) { 
+          return convert<t,double>( src ); 
+      }
+  };
+
+#pragma pack(1)
+
+#ifdef __GNUC__
+  #define ATTRIB_PACKED __attribute__((packed))
+#else
+  #define ATTRIB_PACKED
+#endif
+
+#pragma pack(1)
+  template<class T> struct packed_little_storage {
+  protected:
+      typedef storage_type<T> STORAGE;
+      typedef typename STORAGE::t S;
+      S _val;
+
+      void store( S val ) {
+#ifdef __APPLE__
+          switch ( sizeof( S ) ) {
+          case 8:
+              return OSWriteLittleInt64( &_val, 0, val );
+          case 4:
+              return OSWriteLittleInt32( &_val, 0, val );
+          case 2:
+              return OSWriteLittleInt16( &_val, 0, val );
+      }
+#endif
+
+#if defined(BOOST_LITTLE_ENDIAN) || !defined( ALIGNMENT_IMPORTANT )
+          _val = littleEndian<S>( val );
+#else
+          unsigned char* u_dest = reinterpret_cast<unsigned char*>( &_val );
+          for ( unsigned i = 0; i < sizeof( T ); ++i ) {
+              u_dest[i] = val >> ( 8 * i );
+          }
+#endif
+      }
+
+      S load() const {
+          // Here S should always be an integer type
+#ifdef __APPLE__
+          switch ( sizeof( S ) ) {
+          case 8:
+              return OSReadLittleInt64( &_val, 0 );
+          case 4:
+              return OSReadLittleInt32( &_val, 0 );
+          case 2:
+              return OSReadLittleInt16( &_val, 0 );
+          }
+#endif
+          // Without this trick gcc (4.4.5) compiles 64 bit load to 8 byte loads.
+          // (ppc)
+          if ( sizeof( S ) == 8 && sizeof( void* ) == 4 ) {
+              const packed_little_storage<unsigned>* x = 
+                  reinterpret_cast<const packed_little_storage<unsigned>* >(this);
+              
+              unsigned long long a = x[0];
+              unsigned long long b = x[1];
+              return a | ( b << 32 ); 
+          }
+              
+
+#if defined(BOOST_LITTLE_ENDIAN) || !defined( ALIGNMENT_IMPORTANT )
+          return littleEndian<S>( _val );
+#else
+          S retval = 0;
+          const unsigned char* u_data = 
+              reinterpret_cast<const unsigned char*>( &_val );
+          for( unsigned i = 0; i < sizeof( T ); ++i ) {
+              retval |= S( u_data[i] ) << ( 8 * i );
+          }
+          return retval;
+#endif
+      }
+  public:      
+      inline packed_little_storage& operator=( T val ) {
+          store( STORAGE::toStorage( val ) );
+          return *this;
+      }
+          
+      inline operator T() const {
+          return STORAGE::fromStorage( load() );
+      }
+      
+      
+  } ATTRIB_PACKED ;
+
+#ifdef MONGO_ARM_SPECIAL_ENDIAN
+  template<> struct packed_little_storage<double> {
+  private:
+      double _val;
+  public:
+      inline packed_little_storage<double>& operator=( double val ) {
+          _val = littleEndian<double>( val );
+          return *this;
+      }
+      
+      inline operator double() const {
+          return littleEndian<double>( _val );
+      }
+  } ATTRIB_PACKED ;
+#endif
+
+  template<class T> struct packed_big_storage {
+  private:
+      typedef typename storage_type<T>::t S;
+      S _val;
+  public:
+      
+     packed_big_storage& operator=( T val ) {
+        store_big<S>( &_val, convert<T,S>( val ) );
+        return *this;
+     }
+     
+     operator T() const {
+        return convert<S,T>( load_big<S>( &_val ) );
+     }
+  } ATTRIB_PACKED ;
+
+#ifdef MONGO_ARM_SPECIAL_ENDIAN
+  template<> struct packed_big_storage<double> {
+  private:
+      double _val;
+  public:
+      inline packed_big_storage<double>& operator=( double val ) {
+          _val = bigEndian<double>( val );
+          return *this;
+      }
+      
+      inline operator double() const {
+          return bigEndian<double>( _val );
+      }
+  } ATTRIB_PACKED;
+#endif
+
+
+#pragma pack()
+  
+
+#define MONGO_ENDIAN_REF_FUNCS( TYPE )                          \
+      static TYPE& ref( char* src ) {                           \
+          return *reinterpret_cast<TYPE*>( src );               \
+      }                                                         \
+                                                                \
+      static const TYPE& ref( const char* src ) {               \
+          return *reinterpret_cast<const TYPE*>( src );         \
+      }                                                         \
+                                                                \
+      static TYPE& ref( void* src ) {                           \
+          return ref( reinterpret_cast<char*>( src ) );         \
+      }                                                         \
+                                                                \
+      static const TYPE& ref( const void* src ) {               \
+          return ref( reinterpret_cast<const char*>( src ) );   \
+      }
+
+  template<class T> class little_pod {
+  protected:
+      packed_little_storage<T> _val;
+  public:
+      MONGO_ENDIAN_REF_FUNCS( little_pod );
+      MONGO_ENDIAN_BODY( little_pod, little_pod<T>, T );
+  } ATTRIB_PACKED;
+
+  template<class T> class little : public little_pod<T> {
+  public:
+      inline little( T x ) {
+          *this = x;
+      }
+
+      inline little() {}
+      MONGO_ENDIAN_REF_FUNCS( little );
+      MONGO_ENDIAN_BODY( little, little_pod<T>, T );
+  } ATTRIB_PACKED;
+
+  template<class T> class big_pod {
+  protected:
+      packed_big_storage<T> _val;
+  public:
+      MONGO_ENDIAN_REF_FUNCS( big_pod );
+      MONGO_ENDIAN_BODY( big_pod, big_pod<T>, T );
+  } ATTRIB_PACKED;
+
+  template<class T> class big : public big_pod<T> {
+  public:
+      inline big( T x ) {
+          *this = x;
+      }
+
+      inline big() {}
+      MONGO_ENDIAN_REF_FUNCS( big );
+      MONGO_ENDIAN_BODY( big, big_pod<T>, T );
+  } ATTRIB_PACKED;
+
+  // Helper functions
+  template<class T> T readLE( const void* data ) {
+      return little<T>::ref( data );
+  }
+
+  template<class T> T readBE( const void* data ) {
+      return big<T>::ref( data );
+  }
+
+  template<class T> void copyLE( void* dest, T src ) {
+      little<T>::ref( dest ) = src;
+  }
+
+  template<class T> void copyBE( void* dest, T src ) {
+      big<T>::ref( dest ) = src;
+  }
+
+
+  BOOST_STATIC_ASSERT( sizeof( little_pod<double> ) == 8 );
+  BOOST_STATIC_ASSERT( sizeof( little<double> ) == 8 );
+  BOOST_STATIC_ASSERT( sizeof( big<bool> ) == 1 );
+  BOOST_STATIC_ASSERT( sizeof( little<bool> ) == 1 );
+ 
+  /** Marker class to inherit from to mark that endianess has been taken care of */
+  struct endian_aware { typedef int endian_aware_t; };
+
+  /** To assert that a class has the endian aware marker */
+  #define STATIC_ASSERT_HAS_ENDIAN_AWARE_MARKER( T ) BOOST_STATIC_ASSERT( sizeof( typename T::endian_aware_t ) > 0 )
+
+}
+
+#endif
diff --git a/src/mongo/bson/util/builder.h b/src/mongo/bson/util/builder.h
index a66a736..e9a319d 100644
--- a/src/mongo/bson/util/builder.h
+++ b/src/mongo/bson/util/builder.h
@@ -23,6 +23,7 @@
 #include <stdio.h>
 #include <string>
 #include <string.h>
+#include "bswap.h"
 
 #include "mongo/bson/inline_decls.h"
 #include "mongo/base/string_data.h"
@@ -148,35 +149,43 @@ namespace mongo {
         /* assume ownership of the buffer - you must then free() it */
         void decouple() { data = 0; }
 
+    private:
+        /* 
+         *  Wrap all primitive types in an endian/alignment insensitive way.
+         */
+        template<class T> void append( T j ) {
+            little<T>::ref( grow( sizeof( T ) ) ) = j;
+        }
+    public:
         void appendUChar(unsigned char j) {
-            *((unsigned char*)grow(sizeof(unsigned char))) = j;
+            append<unsigned char>( j );
         }
         void appendChar(char j) {
-            *((char*)grow(sizeof(char))) = j;
+            append<char>( j );
         }
         void appendNum(char j) {
-            *((char*)grow(sizeof(char))) = j;
+            append<char>( j );
         }
         void appendNum(short j) {
-            *((short*)grow(sizeof(short))) = j;
+            append<short>( j );
         }
         void appendNum(int j) {
-            *((int*)grow(sizeof(int))) = j;
+            append<int>( j );
         }
         void appendNum(unsigned j) {
-            *((unsigned*)grow(sizeof(unsigned))) = j;
+            append<unsigned>( j );
         }
         void appendNum(bool j) {
-            *((bool*)grow(sizeof(bool))) = j;
+            append<char>( j );
         }
         void appendNum(double j) {
-            (reinterpret_cast< PackedDouble* >(grow(sizeof(double))))->d = j;
+            append<double>( j );
         }
         void appendNum(long long j) {
-            *((long long*)grow(sizeof(long long))) = j;
+            append<long long>( j );
         }
         void appendNum(unsigned long long j) {
-            *((unsigned long long*)grow(sizeof(unsigned long long))) = j;
+            append<unsigned long long>( j );
         }
 
         void appendBuf(const void *src, size_t len) {
diff --git a/src/mongo/db/auth/privilege_set.cpp b/src/mongo/db/auth/privilege_set.cpp
index c641b65..94d27a1 100644
--- a/src/mongo/db/auth/privilege_set.cpp
+++ b/src/mongo/db/auth/privilege_set.cpp
@@ -79,7 +79,7 @@ namespace mongo {
         resourceSearchList[1] = nsToDatabaseSubstring(desiredPrivilege.getResource());
 
         ActionSet unmetRequirements = desiredPrivilege.getActions();
-        for (int i = 0; i < boost::size(resourceSearchList); ++i) {
+        for (unsigned int i = 0; i < boost::size(resourceSearchList); ++i) {
             ResourcePrivilegeCacheEntry* entry = _lookupEntry(resourceSearchList[i]);
             if (NULL == entry)
                 continue;
diff --git a/src/mongo/db/btree.h b/src/mongo/db/btree.h
index 32e0e23..5162152 100644
--- a/src/mongo/db/btree.h
+++ b/src/mongo/db/btree.h
@@ -88,7 +88,7 @@ namespace mongo {
         short keyDataOfs() const { return (short) _kdo; }
 
         /** Offset within current bucket of the variable width bson key for this _KeyNode. */
-        unsigned short _kdo;
+        little<unsigned short> _kdo;
         void setKeyDataOfs(short s) {
             _kdo = s;
             verify(s>=0);
@@ -148,10 +148,10 @@ namespace mongo {
         /** Given that there are n keys, this is the n index child. */
         DiskLoc nextChild;
         /** can be reused, value is 8192 in current pdfile version Apr2010 */
-        unsigned short _wasSize;
+        little<unsigned short> _wasSize;
         /** zero */
-        unsigned short _reserved1;
-        int flags;
+        little<unsigned short> _reserved1;
+        little<int> flags;
 
         void _init() {
             _reserved1 = 0;
@@ -162,13 +162,13 @@ namespace mongo {
         /** basicInsert() assumes the next three members are consecutive and in this order: */
 
         /** Size of the empty region. */
-        int emptySize;
+        little<int> emptySize;
         /** Size used for bson storage, including storage of old keys. */
-        int topSize;
+        little<int> topSize;
         /* Number of keys in the bucket. */
-        int n;
+        little<int> n;
 
-        int reserved;
+        little<int> reserved;
         /* Beginning of the bucket's body */
         char data[4];
 
@@ -182,16 +182,16 @@ namespace mongo {
         // largest key size we allow.  note we very much need to support bigger keys (somehow) in the future.
         static const int KeyMax = OldBucketSize / 10;
         // A sentinel value sometimes used to identify a deallocated bucket.
-        static const int INVALID_N_SENTINEL = -1;
+        enum { INVALID_N_SENTINEL = -1 };
     };
 
     // a a a ofs ofs ofs ofs
     class DiskLoc56Bit {
-        int ofs;
+        little<int> ofs;
         unsigned char _a[3];
         unsigned long long Z() const { 
             // endian
-            return *((unsigned long long*)this) & 0x00ffffffffffffffULL;
+            return little<unsigned long long>::ref(this) & 0x00ffffffffffffffULL;
         }
         enum { 
             // first bit of offsets used in _KeyNode we don't use -1 here.
@@ -209,10 +209,10 @@ namespace mongo {
         operator const DiskLoc() const { 
             // endian
             if( isNull() ) return DiskLoc();
-            unsigned a = *((unsigned *) (_a-1));
+            unsigned a = little<unsigned>::ref( _a - 1 );
             return DiskLoc(a >> 8, ofs);
         }
-        int& GETOFS()      { return ofs; }
+        little<int>& GETOFS()      { return ofs; }
         int getOfs() const { return ofs; }
         bool operator<(const DiskLoc56Bit& rhs) const {
             // the orderering of dup keys in btrees isn't too critical, but we'd like to put items that are 
@@ -250,7 +250,8 @@ namespace mongo {
                 la = 0;
                 ofs = OurNullOfs;
             }
-            memcpy(_a, &la, 3); // endian
+            little<int> lila = la;
+            memcpy(_a, &lila, 3); // endian
         }
         DiskLoc56Bit& writing() const { 
             return *((DiskLoc56Bit*) getDur().writingPtr((void*)this, 7));
@@ -275,14 +276,14 @@ namespace mongo {
         /** Given that there are n keys, this is the n index child. */
         Loc nextChild;
 
-        unsigned short flags;
+        little<unsigned short> flags;
 
         /** basicInsert() assumes the next three members are consecutive and in this order: */
 
         /** Size of the empty region. */
-        unsigned short emptySize;
+        little<unsigned short> emptySize;
         /** Size used for bson storage, including storage of old keys. */
-        unsigned short topSize;
+        little<unsigned short> topSize;
         /* Number of keys in the bucket. */
         unsigned short n;
 
diff --git a/src/mongo/db/commands/storage_details.cpp b/src/mongo/db/commands/storage_details.cpp
index 9197ce2..3165973 100644
--- a/src/mongo/db/commands/storage_details.cpp
+++ b/src/mongo/db/commands/storage_details.cpp
@@ -49,12 +49,12 @@ namespace {
      */
     struct AnalyzeParams {
         // startOfs and endOfs are extent-relative
-        int startOfs;
-        int endOfs;
-        int length;
-        int numberOfSlices;
-        int granularity;
-        int lastSliceLength;
+        little<int> startOfs;
+        little<int> endOfs;
+        little<int> length;
+        little<int> numberOfSlices;
+        little<int> granularity;
+        little<int> lastSliceLength;
         string characteristicField;
         bool processDeletedRecords;
         bool showRecords;
@@ -676,7 +676,7 @@ namespace {
     bool analyzeExtent(const NamespaceDetails* nsd, const Extent* ex, SubCommand subCommand,
                        AnalyzeParams& params, string& errmsg, BSONObjBuilder& outputBuilder) {
 
-        params.startOfs = max(0, params.startOfs);
+        params.startOfs = max((little<int>)0, params.startOfs);
         params.endOfs = min(params.endOfs, ex->length);
         params.length = params.endOfs - params.startOfs;
         if (params.numberOfSlices != 0) {
diff --git a/src/mongo/db/curop.h b/src/mongo/db/curop.h
index 30d94d2..2d50fe9 100644
--- a/src/mongo/db/curop.h
+++ b/src/mongo/db/curop.h
@@ -109,7 +109,7 @@ namespace mongo {
         static BSONObj _tooBig; // { $msg : "query not recording (too large)" }
 
         CachedBSONObj() {
-            _size = (int*)_buf;
+            _size = &little<int>::ref( _buf );
             reset();
         }
 
@@ -159,7 +159,7 @@ namespace mongo {
         void _reset( int sz ) { _size[0] = sz; }
 
         mutable SpinLock _lock;
-        int * _size;
+        little<int> * _size;
         char _buf[512];
     };
 
diff --git a/src/mongo/db/db.cpp b/src/mongo/db/db.cpp
index 046101a..b4fec43 100644
--- a/src/mongo/db/db.cpp
+++ b/src/mongo/db/db.cpp
@@ -1289,7 +1289,7 @@ static int mongoDbMain(int argc, char* argv[], char **envp) {
     {
         unsigned x = 0x12345678;
         unsigned char& b = (unsigned char&) x;
-        if ( b != 0x78 ) {
+        if ( 0 && b != 0x78 ) {
             out() << "big endian cpus not yet supported" << endl;
             return 33;
         }
diff --git a/src/mongo/db/dbmessage.h b/src/mongo/db/dbmessage.h
index 50658dd..089efc3 100644
--- a/src/mongo/db/dbmessage.h
+++ b/src/mongo/db/dbmessage.h
@@ -82,16 +82,16 @@ namespace mongo {
 
 #pragma pack(1)
     struct QueryResult : public MsgData {
-        long long cursorId;
-        int startingFrom;
-        int nReturned;
+        little<long long> cursorId;
+        little<int> startingFrom;
+        little<int> nReturned;
         const char *data() {
-            return (char *) (((int *)&nReturned)+1);
+            return reinterpret_cast<char*>( &nReturned ) + 4;
         }
         int resultFlags() {
             return dataAsInt();
         }
-        int& _resultFlags() {
+        little<int>& _resultFlags() {
             return dataAsInt();
         }
         void setResultFlagsToOk() {
diff --git a/src/mongo/db/diskloc.h b/src/mongo/db/diskloc.h
index 70acc97..d192841 100644
--- a/src/mongo/db/diskloc.h
+++ b/src/mongo/db/diskloc.h
@@ -42,8 +42,8 @@ namespace mongo {
         (such as adding a virtual function)
      */
     class DiskLoc {
-        int _a;     // this will be volume, file #, etc. but is a logical value could be anything depending on storage engine
-        int ofs;
+        little<int> _a;     // this will be volume, file #, etsc. but is a logical value could be anything depending on storage engine
+        little<int> ofs;
 
     public:
 
@@ -94,7 +94,7 @@ namespace mongo {
 
         int a() const { return _a; }
 
-        int& GETOFS()      { return ofs; }
+        little<int>& GETOFS()      { return ofs; }
         int getOfs() const { return ofs; }
         void set(int a, int b) {
             _a=a;
diff --git a/src/mongo/db/dur.h b/src/mongo/db/dur.h
index 604ed2e..b5ba774 100644
--- a/src/mongo/db/dur.h
+++ b/src/mongo/db/dur.h
@@ -126,7 +126,7 @@ namespace mongo {
             inline DiskLoc& writingDiskLoc(DiskLoc& d) { return *((DiskLoc*) writingPtr(&d, sizeof(d))); }
 
             /** Declare write intent for an int */
-            inline int& writingInt(int& d) { return *static_cast<int*>(writingPtr( &d, sizeof(d))); }
+            inline little<int>& writingInt( little<int>& d) { return *static_cast<little<int>*>(writingPtr( &d, sizeof(d))); }
 
             /** "assume i've already indicated write intent, let me write"
                 redeclaration is fine too, but this is faster.
